import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.security.*;
import java.io.*;

//*******************************************************************
public class desEncryption extends JApplet
{
	JLabel keyLabel = new JLabel( "" );
	JLabel keyField = new JLabel( "" );

	//Add raw-text text area
	JTextArea rawText = new JTextArea( "", 25, 25 );
	JTextArea cipherTextArea = new JTextArea( "", 25, 25 );

	Vector keyVector = new Vector();
	String vectorString = "";

	//Define and populate the permutation table
	int initialPermutation[] =
	{
		58,50,42,34,26,18,10,2,
		60,52,44,36,28,20,12,4,
		62,54,46,38,30,22,14,6,
		64,56,48,40,32,24,16,8,
		57,49,41,33,25,17,9,1,
		59,51,43,35,27,19,11,3,
		61,53,45,37,29,21,13,5,
		63,55,47,39,31,23,15,7
	};

	//Define and populate the inverse permutation tables
	int initialPermutationInverse[] =
	{
		40,8,48,16,56,24,64,32,
		39,7,47,15,55,23,63,31,
		38,6,46,14,54,22,62,30,
		37,5,45,13,53,21,61,29,
		36,4,44,12,52,20,60,28,
		35,3,43,11,51,19,59,27,
		34,2,42,10,50,18,58,26,
		33,1,41,9,49,17,57,25
	};


	//*******************************************************************
	public String decrypt( String cipherText, String privateKey)
	{
		String plainText="", sixtyFourBitString="", zeroString="";
		String finalString="", decryptedString="";
		String LiString="", RiString="", charString="", tempKeyString="";

		int cipherTextLength=0, i=0, j=0, k=0, charNum=0, charCount=0, size=0;

		Vector blockVector = new Vector();
		Vector keyVector = new Vector();

		Vector LiMinus1 = new Vector();
		Vector RiMinus1 = new Vector();
		Vector Li = new Vector();
		Vector Ri = new Vector();
		Vector RiMinus1Final = new Vector();

		Vector tempVector = new Vector( 64 );

		BitSet tempBitSet = new BitSet( 32 );
		BitSet RiBitSet = new BitSet( 32 );

		int ip1, ip2;

		char c;

		String[] RiMinus1A = new String[32];
		String[] LiMinus1A = new String[32];
		String[] LiA = new String[32];

		String[] subkeys = new String[16];
		String[] subkeySwapVector = new String[16];

		Vector reversePermutedVector = new Vector();

		//Parse byte string into 64 bit blocks.
		while( cipherText.length() > 0 )
		{
			sixtyFourBitString = cipherText.substring( 0, 64 );
			cipherTextLength = cipherText.length();
			cipherText = cipherText.substring( 64, ( cipherTextLength ) );

			//Add block to vector
			blockVector.addElement( sixtyFourBitString );
		}

		//Put privateKey into a Vector and pass to generateSubkeys to... generate the subkeys
		for( j=0 ; j<64 ; j++ )
		{
			keyVector.insertElementAt( privateKey.substring( j, j+1 ) , j );
		}

		subkeys = generateSubkeys( keyVector );

		//set i for key swap
		i = 15;

		//for decryption subkey must be reversed
		for( j=0 ; j<16 ; j++ )
		{
			subkeySwapVector[j] = subkeys[i];
			i--;
		}

		//This is the main code for performing the actual decryption steps
		for( i=0 ; i<blockVector.size() ; i++ )
		{
			//take the first block out of the blockVector
			sixtyFourBitString = (String)blockVector.elementAt( i );

			//Clear all bitsets
			tempBitSet.clear();
			RiBitSet.clear();

			//perform reverse permutation
			for( j=0 ; j<64 ; j++ )
			{
				try
				{
					ip1 = initialPermutation[j]-1;
					ip2 = initialPermutation[j];
					reversePermutedVector.insertElementAt( sixtyFourBitString.substring( ip1, ip2 ), j );
				}
				catch( Exception e )
				{
					ip1 = initialPermutation[j]-1;
					ip2 = initialPermutation[j];
					reversePermutedVector.set( j, sixtyFourBitString.substring( ip1, ip2 ) );
				}
			}

			//split into left and right halves
			for( j=0 ; j<32 ; j++ )
			{
				try
				{
					Li.set( j, reversePermutedVector.elementAt( j ) );
				}
				catch( Exception e )
				{
					Li.insertElementAt( reversePermutedVector.elementAt( j ), j );
				}
			}

			for( j=32 ; j<64 ; j++ )
			{
				try
				{
					Ri.set( j-32, reversePermutedVector.elementAt( j ) );
				}
				catch( Exception e )
				{
					Ri.insertElementAt( reversePermutedVector.elementAt( j ), j-32 );
				}
			}

			//perform individual rounds of decryption
			for( j=0 ; j<16 ; j++ )
			{
				//if not first round then
				if( j != 0 )
				{
					for( k=0 ; k<32 ; k++ )
						RiMinus1A[k] = (String)RiMinus1.elementAt( k );
					for( k=0 ; k<32 ; k++ )
						LiMinus1A[k] = (String)LiMinus1.elementAt( k );

					Ri.clear();
					Li.clear();

					for( k=0 ; k<32 ; k++ )
						Ri.insertElementAt( RiMinus1A[k], k );
					for( k=0 ; k<32 ; k++ )
						Li.insertElementAt( LiMinus1A[k], k );
				}

				for( k=0 ; k<32 ; k++ )
					LiA[k] = (String)Li.elementAt( k );

				RiMinus1.clear();

				for( k=0 ; k<32 ; k++ )
					RiMinus1.insertElementAt( LiA[k], k );

 				//Clean up string (remove [, ], space and comma
				tempKeyString = cleanString( subkeySwapVector[j] );

				tempVector = f( Li, tempKeyString );

				if( j != 0 )
					tempBitSet.clear();

				//Convert tempVector to BitSet
				for( k=0 ; k<32 ; k++ )
				{
					if( tempVector.elementAt( k ).equals( "1" ) )
						tempBitSet.set( k );
				}

				if( j != 0 )
					RiBitSet.clear();

				//Convert Ri to BitSet
				for( k=0 ; k<32 ; k++ )
				{
					if( Ri.elementAt( k ).equals( "1" ) )
						RiBitSet.set( k );
				}

				RiBitSet.xor( tempBitSet );

				LiMinus1.clear();

				//Convert RiBitSet into Vector LiMinus1
				for( k=0 ; k<32 ; k++ )
				{
					if( RiBitSet.get( k ) )
					{
						LiMinus1.insertElementAt( "1", k );
					}
					else
					{
						LiMinus1.insertElementAt( "0", k );
					}
				}
			}

			decryptedString = "";

			//concat LiMinus1 to a string
			for( j=0 ; j<32 ; j++ )
			{
				decryptedString += (String)LiMinus1.elementAt( j );
			}

			//concat RiMinus1 to same string
			for( j=0 ; j<32 ; j++ )
			{
				decryptedString += (String)RiMinus1.elementAt( j );
			}

			tempVector.clear();

			//perform IP
			for( j=0 ; j<64 ; j++ )
			{
				ip1 = initialPermutationInverse[j]-1;
				ip2 = initialPermutationInverse[j];
				tempVector.insertElementAt( decryptedString.substring( ip1, ip2 ), j );
			}

			decryptedString = "";

			for( j=0 ; j<64 ; j++ )
			{
				decryptedString += (String)tempVector.elementAt( j );
			}

			//Collect encrypted block from end of each 16 rounds
			finalString += decryptedString;
		}

		charString = "";

		charCount = 0;
		for( i=0 ; i<finalString.length() ; i+=8 )
		{
			c = binaryToChar( finalString.substring( i, i+8 ) );
			System.out.println( c );
			charString += c;
			charCount++;
		}

		return( charString );
	}
	//*******************************************************************



	//*******************************************************************
	public char binaryToChar( String num )
	{
		char c;
		int charNum=0;

		charNum = Integer.parseInt( num, 2);
		c = (char)(charNum & 0xff);

		return( c );
	}
	//*******************************************************************



	//*******************************************************************
	public String encrypt( String plainText, String privateKey)
	{
		String cipherText="";
		Vector blockVector = new Vector();
		Vector permutedBlockVector = new Vector();
		Vector bitVector = new Vector();
		Vector permutedBitVector = new Vector();

		Vector LiMinus1 = new Vector();
		Vector RiMinus1 = new Vector();

		Vector keyVector = new Vector();

		Vector Li = new Vector();
		Vector Ri = new Vector();

		Vector temp = new Vector();

		int ip1, ip2;

		String paddedText="";
		String byteString="", sixtyFourBitString="", zeroString="", encryptedString="";
		int i=0, j=0, k=0, l=0, byteIndex=0, byteStringLength=0, size=0;

		String charString="", tempKeyString, LiString="", RiString="", finalString="";

		char[] chars = new char[ plainText.length() ];
		byte[] bytes = new byte[1];

		BitSet LiMinus1BitSet = new BitSet( 32 );
		BitSet tempBitSet = new BitSet( 32 );

		String[] subkeys = new String[16];

		chars = plainText.toCharArray();

		for( i=0 ; i<plainText.length() ; i++ )
		{
			bytes = charToByteArray( chars[i] );
			byteString += ( decimalToBinary( bytes[0] ) );
		}

		//Parse byte string into 64 bit blocks. Pad the last block if necessary
		while( byteString.length() > 0 )
		{
			try
			{
				sixtyFourBitString = byteString.substring( 0, 64 );
				byteStringLength = byteString.length();
				byteString = byteString.substring( 64, ( byteStringLength ) );

				//Add block to vector
				blockVector.addElement( sixtyFourBitString );

				size += 64;
				paddedText += sixtyFourBitString;
			}
			catch( StringIndexOutOfBoundsException e )
			{
				sixtyFourBitString = byteString.trim();

				//build zero (padding so all blocks satisfy length mod 64 = 0
				for( i=0 ; i<( 64 - sixtyFourBitString.length() ) ; i++ )
					zeroString += "0";

				sixtyFourBitString = sixtyFourBitString + zeroString;

				//Add block to vector
				blockVector.addElement( sixtyFourBitString );

				byteString = "";
				size += 64;
				paddedText += sixtyFourBitString;
			}
		}

		//Put privateKey into a Vector and pass to generateSubkeys to... gen subkeys
		for( j=0 ; j<64 ; j++ )
		{
			keyVector.insertElementAt( privateKey.substring( j, j+1 ) , j );
		}

		subkeys = generateSubkeys( keyVector );

		//This is the main code for performing the actual encryption steps
		for( i=0 ; i<blockVector.size() ; i++ )
		{
			//Empty temp vectors
			LiMinus1.clear();
			RiMinus1.clear();
			Li.clear();
			Ri.clear();

			//take the first block out of the blockVector
			sixtyFourBitString = (String)blockVector.elementAt( i );

			bitVector.clear();

			//populate bitVector with individual bits of current block
			for( j=0 ; j<64 ; j++ )
			{
				charString = sixtyFourBitString.substring( j, j+1 );
				bitVector.insertElementAt( charString, j );
			}

			permutedBitVector.clear();

			//Perform Initial Permutation
			for( j=0 ; j<64 ; j++ )
			{
				ip1 = initialPermutation[j]-1;
				permutedBitVector.insertElementAt( bitVector.elementAt( ip1 ), j );
			}

			//put the left hand side into a 32 space vector for 16 rounds
			for( j=0 ; j<32 ; j++ )
			{
				LiMinus1.insertElementAt( permutedBitVector.elementAt( j ), j );
			}

			//put the right hand side into a 32 space vector for 16 rounds
			for( j=32 ; j<64 ; j++ )
			{
				RiMinus1.insertElementAt( permutedBitVector.elementAt( j ), ( j-32 ) );
			}

			//begin rounds of encryption. Rounds denoted by j (ie. j+1 th round)
			for( j=0 ; j<16 ; j++ )
			{
				tempKeyString="";

				//If not first round, set Ri to Ri-1
				if( j != 0 )
					RiMinus1 = Ri;

				//If not first round, set Li to Li-1
				if( j != 0 )
					LiMinus1 = Li;

				Li = RiMinus1;

				LiString="";
				RiString="";

				//Left hand side of encrypted text
				for( k=0 ; k<32 ; k++ )
				{
					LiString += (String)Li.elementAt( k );
				}

				//Clean up string (remove [, ], space and comma
				tempKeyString = cleanString( subkeys[j] );

				//Perform complex function
				temp = f( RiMinus1, tempKeyString );

				//convert LiMinus1 to BitSet
				for( k=0 ; k<32 ; k++ )
				{
					if( LiMinus1.elementAt( k ).equals( "1" ) )
						LiMinus1BitSet.set( k );
				}

				//Convert temp Vector to BitSet
				for( k=0 ; k<32 ; k++ )
				{
					if( temp.elementAt( k ).equals( "1" ) )
						tempBitSet.set( k );
				}

				//XOR LiMinus1 and temp
				LiMinus1BitSet.xor( tempBitSet );

				//Empty temp for another use
				temp.clear();

				//Convert LiMinus1BitSet into Vector temp
				for( k=0 ; k<32 ; k++ )
				{
					if( LiMinus1BitSet.get( k ) )
					{
						temp.insertElementAt( "1", k );
					}
					else
					{
						temp.insertElementAt( "0", k );
					}
				}

				//Assign temp to Ri....thus ends a round of encryption
				Ri = temp;

				LiMinus1BitSet.clear();
				tempBitSet.clear();
			}

			//Clear vector for next block
			permutedBitVector.clear();

			RiString = "";

			//Left hand side of encrypted text
			for( k=0 ; k<32 ; k++ )
			{
				RiString += (String)Ri.elementAt( k );
			}

			//Ciphertext equals this block(encrypted)
			cipherText = LiString + RiString;

			encryptedString = "";

			//Apply final permutation
			for( k=0 ; k<64 ; k++ )
			{
				ip1 = initialPermutationInverse[k]-1;
				ip2 = initialPermutationInverse[k];
				encryptedString += cipherText.substring( ip1, ip2 );
			}

			//Collect encrypted block from end of each 16 rounds
			finalString += encryptedString;
		}

		return( finalString );
	}
	//*******************************************************************



	//*******************************************************************
	//not the best way, but constrained for time. key string contains [ and ] and ,
	//and spaces. Go back and improve later IF time permits.
	public String cleanString( String dirtyString )
	{
		String tempString="";
		int l;

		for( l=0 ; l<dirtyString.length() ; l++ )
		{
			if( dirtyString.substring( l, l+1 ).equals( "1" ) ||
			    dirtyString.substring( l, l+1 ).equals( "0" ) )
				tempString += dirtyString.substring( l, l+1 );
		}

		return( tempString );
	}
	//*******************************************************************



	//*******************************************************************
	public Vector f( Vector RiMinus1, String Ki )
	{
		Vector permutedVector = new Vector();
		Vector expandedRiMinus1 = new Vector();
		Vector xoredVector = new Vector();

		BitSet keyBits = new BitSet( 48 );
		BitSet expandedBits = new BitSet( 48 );

		String XORed="", sBoxed="";
		int i=0, incrementer;

		int ip1, ip2;

		//Define and populate the permutation table
		int expansionPermutation[] =
		{
			32, 1, 2, 3, 4, 5,
			4, 5, 6, 7, 8, 9,
			8, 9, 10, 11, 12, 13,
			12, 13, 14, 15, 16, 17,
			16, 17, 18, 19, 20, 21,
			20, 21, 22, 23, 24, 25,
			24, 25, 26, 27, 28, 29,
			28, 29, 30, 31, 32, 1
		};

		//Define final permutation table
		int finalPermutation[] =
		{
			16, 7, 20, 21, 29, 12, 28, 17,
			1, 15, 23, 26, 5, 18, 31, 10,
			2, 8, 24, 14, 32, 27, 3, 9,
			19, 13, 30, 6, 22, 11, 4, 25
		};

		//Expand Right Hand Side
		for( i=0 ; i<48 ; i++ )
		{
			ip1 = expansionPermutation[i]-1;
			expandedRiMinus1.insertElementAt( RiMinus1.elementAt( ip1 ), i );
		}

		//initialize all bits in BitSet to false
		keyBits.clear();

		//Place the 48 bit subkey into a BitSet for use of the XOR method
		for( i=0 ; i<48 ; i++ )
		{
			if( Ki.substring( i, i+1 ).equals( "1" ) )
				keyBits.set( i );
		}

		//Place the expanded side into a BitSet for use of the XOR method
		for( i=0 ; i<48 ; i++ )
		{
			if( expandedRiMinus1.elementAt( i ).equals( "1" ) )
				expandedBits.set( i );
		}

		//Perform XOR
		expandedBits.xor( keyBits );

		//Convert XORed bitset into String
		for( i=0 ; i<48 ; i++ )
		{
			if( expandedBits.get( i ) )
				XORed += "1";
			else
				XORed += "0";
		}

		incrementer = 0;

		//Apply S-Boxes to XORed
		for( i=0 ; i<8 ; i++ )
		{
			sBoxed += applySbox( XORed.substring( incrementer, incrementer+6 ), i+1 );

			incrementer += 6;
		}

		//Apply final permutation
		for( i=0 ; i<32 ; i++ )
		{
			ip1 = finalPermutation[i]-1;
			ip2 = finalPermutation[i];
			permutedVector.insertElementAt( sBoxed.substring( ip1, ip2 ), i );
		}

		return( permutedVector );
	}
	//*******************************************************************



	//*******************************************************************
	public String applySbox( String sixBits, int sBoxChoice )
	{
		int rowNumber=0, columnNumber=0;

		String fourBits="";

		//Define sBox 1
		int s1[][] =
		{
			{14,4,13,1,2,15,11,8,3,10,6,12,5,9,0,7},
			{0,15,7,4,14,2,13,1,10,6,12,11,9,5,3,8},
			{4,1,14,8,13,6,2,11,15,12,9,7,3,10,5,0},
			{15,12,8,2,4,9,1,7,5,11,3,14,10,0,6,13}
		};

		if( sBoxChoice == 1 )
		{
			//extract row number
			rowNumber = Integer.parseInt( sixBits.substring( 0, 1 ) + sixBits.substring( 5, 6 ), 2 );

			//extract column number
			columnNumber = Integer.parseInt( sixBits.substring( 1, 5 ), 2);

			fourBits = decimalToBinary( s1[rowNumber][columnNumber] ).substring( 4, 8 );
		}

		//Define sBox 2
		int s2[][] =
		{
			{15,1,8,14,6,11,3,4,9,7,2,13,12,0,5,10},
 			{3,13,4,7,15,2,8,14,12,0,1,10,6,9,11,5},
 			{0,14,7,11,10,4,13,1,5,8,12,6,9,3,2,15},
			{13,8,10,1,3,15,4,2,11,6,7,12,0,5,14,9}
		};

		if( sBoxChoice == 2 )
		{
			//extract row number
			rowNumber = Integer.parseInt( sixBits.substring( 0, 1 ) + sixBits.substring( 5, 6 ), 2 );

			//extract column number

			columnNumber = Integer.parseInt( sixBits.substring( 1, 5 ), 2);

			fourBits = decimalToBinary( s2[rowNumber][columnNumber] ).substring( 4, 8 );
		}

		//Define sBox3
		int s3[][] =
		{
			{10,0,9,14,6,3,15,5,1,13,12,7,11,4,2,8},
			{13,7,0,9,3,4,6,10,2,8,5,14,12,11,15,1},
			{13,6,4,9,8,15,3,0,11,1,2,12,5,10,14,7},
			{1,10,13,0,6,9,8,7,4,15,14,3,11,5,2,12}
		};

		if( sBoxChoice == 3 )
		{
			//extract row number
			rowNumber = Integer.parseInt( sixBits.substring( 0, 1 ) + sixBits.substring( 5, 6 ), 2 );

			//extract column number
			columnNumber = Integer.parseInt( sixBits.substring( 1, 5 ), 2);

			fourBits = decimalToBinary( s3[rowNumber][columnNumber] ).substring( 4, 8 );
		}

		//Define sBox4
		int s4[][] =
		{
			{7,13,14,3,0,6,9,10,1,2,8,5,11,12,4,15},
			{13,8,11,5,6,15,0,3,4,7,2,12,1,10,14,9},
			{10,6,9,0,12,11,7,13,15,1,3,14,5,2,8,4},
			{3,15,0,6,10,1,13,8,9,4,5,11,12,7,2,14}
		};

		if( sBoxChoice == 4 )
		{

			//extract row number
			rowNumber = Integer.parseInt( sixBits.substring( 0, 1 ) + sixBits.substring( 5, 6 ), 2 );

			//extract column number
			columnNumber = Integer.parseInt( sixBits.substring( 1, 5 ), 2);

			fourBits = decimalToBinary( s4[rowNumber][columnNumber] ).substring( 4, 8 );
		}

		//Define sBox5
		int s5[][] =
		{
			{2,12,4,1,7,10,11,6,8,5,3,15,13,0,14,9},
			{14,11,2,12,4,7,13,1,5,0,15,10,3,9,8,6},
			{4,2,1,11,10,13,7,8,15,9,12,5,6,3,0,14},
			{11,8,12,7,1,14,2,13,6,15,0,9,10,4,5,3}
		};

		if( sBoxChoice == 5 )
		{
			//extract row number
			rowNumber = Integer.parseInt( sixBits.substring( 0, 1 ) + sixBits.substring( 5, 6 ), 2 );

			//extract column number
			columnNumber = Integer.parseInt( sixBits.substring( 1, 5 ), 2);

			fourBits = decimalToBinary( s5[rowNumber][columnNumber] ).substring( 4, 8 );
		}

		//Define sBox6
		int s6[][] =
		{
			{12,1,10,15,9,2,6,8,0,13,3,4,14,7,5,11},
			{10,15,4,2,7,12,9,5,6,1,13,14,0,11,3,8},
			{9,14,15,5,2,8,12,3,7,0,4,10,1,13,11,6},
			{4,3,2,12,9,5,15,10,11,14,1,7,6,0,8,13}
		};

		if( sBoxChoice == 6 )
		{
			//extract row number
			rowNumber = Integer.parseInt( sixBits.substring( 0, 1 ) + sixBits.substring( 5, 6 ), 2 );

			//extract column number
			columnNumber = Integer.parseInt( sixBits.substring( 1, 5 ), 2);

			fourBits = decimalToBinary( s6[rowNumber][columnNumber] ).substring( 4, 8 );
		}

		//Define sBox7
		int s7[][] =
		{
			{4,11,2,14,15,0,8,13,3,12,9,7,5,10,6,1},
			{13,0,11,7,4,9,1,10,14,3,5,12,2,15,8,6},
			{1,4,11,13,12,3,7,14,10,15,6,8,0,5,9,2},
			{6,11,13,8,1,4,10,7,9,5,0,15,14,2,3,12}
		};

		if( sBoxChoice == 7 )
		{
			//extract row number
			rowNumber = Integer.parseInt( sixBits.substring( 0, 1 ) + sixBits.substring( 5, 6 ), 2 );

			//extract column number
			columnNumber = Integer.parseInt( sixBits.substring( 1, 5 ), 2);

			fourBits = decimalToBinary( s7[rowNumber][columnNumber] ).substring( 4, 8 );
		}

		//Define sBox 8
		int s8[][] =
		{
			{13,2,8,4,6,15,11,1,10,9,3,14,5,0,12,7},
			{1,15,13,8,10,3,7,4,12,5,6,11,0,14,9,2},
			{7,11,4,1,9,12,14,2,0,6,10,13,15,3,5,8},
			{2,1,14,7,4,10,8,13,15,12,9,0,3,5,6,11}
		};

		if( sBoxChoice == 8 )
		{
			//extract row number
			rowNumber = Integer.parseInt( sixBits.substring( 0, 1 ) + sixBits.substring( 5, 6 ), 2 );

			//extract column number
			columnNumber = Integer.parseInt( sixBits.substring( 1, 5 ), 2);

			fourBits = decimalToBinary( s8[rowNumber][columnNumber] ).substring( 4, 8 );
		}

		return( fourBits );
	}
	//*******************************************************************

	//*******************************************************************
	public String[] generateSubkeys( Vector privateKey )
	{
		//Create necessary vectors
		Vector subkeys = new Vector();
		Vector subkey = new Vector();
		Vector tempSubkey = new Vector();

		Vector c0 = new Vector();
		Vector d0 = new Vector();

		Vector c0Shifted = new Vector();
		Vector d0Shifted = new Vector();

		int i=0, j=0, k=0, ip1;

		String[] keyArray = new String[16];

		Vector permutedPrivateKey = new Vector();

		//Define and populate subkey permutation tablel 1
		int subkeyPermutationTable1[] =
		{
			57,49,41,33,25,17,9,
			1,58,50,42,34,26,18,
			10,2,59,51,43,35,27,
			19,11,3,60,52,44,36,
			63,55,47,39,31,23,15,
			7,62,54,46,38,30,22,
			14,6,61,53,45,37,29,
			21,13,5,28,20,12,4
		};

		//Define and populate subkey permutation tablel 2
		int subkeyPermutationTable2[] =
		{
			14,17,11,24,1,5,3,28,
			15,6,21,10,23,19,12,4,
			26,8,16,7,27,20,13,2,
			41,52,31,37,47,55,30,40,
			51,45,33,48,44,49,39,56,
			34,53,46,42,50,36,29,32,
		};

		//Define and populate bit shifting schedule
		int bitShiftSchedule[] = {1,1,2,2,2,2,2,2,1,2,2,2,2,2,2,1};

		//calculate initial permutation of private key using subkeyPermutationTable1
		for( i=0 ; i<56 ; i++ )
		{
			ip1 = subkeyPermutationTable1[i]-1;
			permutedPrivateKey.insertElementAt( privateKey.elementAt( ( ip1 ) ) , i );
		}

		//populate d0
		for( i=0 ; i<28 ; i++ )
		{
			c0.insertElementAt( permutedPrivateKey.elementAt(i), i );
		}

		//populate c0
		for( i=28 ; i<56 ; i++ )
		{
			d0.insertElementAt( permutedPrivateKey.elementAt(i), (i-28) );
		}

		//put subkeys into one vector for return
		for( i=0 ; i<16 ; i++ )
		{

			//make shifted subkey
			c0Shifted = shiftLeft( bitShiftSchedule[i], c0 );
			d0Shifted = shiftLeft( bitShiftSchedule[i], d0 );

			tempSubkey.clear();

			//populate the subkey Vector
			for( j=0 ; j<56 ; j++ )
			{
				if( j<28 )
					tempSubkey.insertElementAt( c0Shifted.elementAt(j), j );
				else
					tempSubkey.insertElementAt( d0Shifted.elementAt( j-28 ), j );
			}

			//permute the post-shifted key using subkeyPermutationTable2
			for( k=0 ; k<48 ; k++ )
			{
				ip1 = subkeyPermutationTable2[k]-1;
				subkey.insertElementAt( tempSubkey.elementAt( ( ip1 ) ), k );
			}

			//set c0 and d0 to the new values
			c0 = c0Shifted;
			d0 = d0Shifted;

			//add the new subkey to the complete subkeys vector
			//subkeys.insertElementAt( subkey, i );
			keyArray[i] = subkey.toString();
			subkey.clear();
		}

		return( keyArray );
	}
	//*******************************************************************


	//*******************************************************************
	//This function takes a Vector as input and a number of shifts, and
	//shifts the vector circularly the specific number of shifts
	//specified and returns a new Array
	public Vector shiftLeft( int numberOfShifts, Vector key )
	{
		Vector tempVector = new Vector( 28, 4 );
		int j=0, i=0, positionPointer=0;
		int resetTag=0;

		positionPointer = numberOfShifts;

		//Initialize vector positions
		Integer x = new Integer( 3 );
		for( i=0 ; i<28 ; i++ )
			tempVector.insertElementAt( x, i );

		//perform the shift
		for( j=0 ; j<28 ; j++ )
		{
			if( j > ( 27-numberOfShifts ) && resetTag != 1)
			{
				positionPointer = 0;
				resetTag = 1;
			}

			tempVector.insertElementAt( key.elementAt( positionPointer ), j );
			positionPointer++;
		}
		tempVector.setSize( 28 );
		return( tempVector );
	}
	//*******************************************************************


	//*******************************************************************
	//This function generates a pseudo-random 64-bit key and returns it
	//in Vector form
	public Vector autogenKey()
	{
		Vector keyVector = new Vector();
		int goodKey=0;

		while( goodKey != 1 )
		{
			//Four different "random" generators because only made to many
			//consecutive ones or zeros
			Random randomKeyBit = new Random();
			Integer keyBit;
			int i=0;

			for( i=0 ; i<64 ; i++ )
			{
				keyBit = new Integer( randomKeyBit.nextInt( 2 ) );
				keyVector.addElement( keyBit );
			}
			goodKey = checkIfWeakKey( keyVector );
		}

		return keyVector;
	}
	//*******************************************************************


	//*******************************************************************
	public int checkIfWeakKey( Vector keyVector )
	{
		String weakKeys[] = new String[4];
		String semiWeakKeys[] = new String[12];
		String demiSemiWeakKeys[] = new String[49];

		String keyString="";
		int i=0, keyHitCount=0, ip1;

		Vector permutedPrivateKey = new Vector();

		//Define and populate subkey permutation tablel 1
		int subkeyPermutationTable1[] =
		{
			57,49,41,33,25,17,9,
			1,58,50,42,34,26,18,
			10,2,59,51,43,35,27,
			19,11,3,60,52,44,36,
			63,55,47,39,31,23,15,
			7,62,54,46,38,30,22,
			14,6,61,53,45,37,29,
			21,13,5,28,20,12,4
		};

		//Extract the key from the vector
		for( i=0 ; i<64 ; i++ )
		{
			keyString += keyVector.elementAt( i );
		}

		permutedPrivateKey.clear();

		//calculate initial permutation of private key using subkeyPermutationTable1
		for( i=0 ; i<56 ; i++ )
		{
			ip1 = subkeyPermutationTable1[i]-1;
			permutedPrivateKey.insertElementAt( keyVector.elementAt( ( ip1 ) ) , i );
		}

		keyString = "";

		//Extract the key from the permuted vector
		for( i=0 ; i<56 ; i++ )
		{
			keyString += permutedPrivateKey.elementAt( i );
		}

		//Set the weak keys
		weakKeys[0] = "00000000000000000000000000000000000000000000000000000000";
		weakKeys[1] = "11111111111111111111111111110000000000000000000000000000";
		weakKeys[2] = "00000000000000000000000000001111111111111111111111111111";
		weakKeys[3] = "11111111111111111111111111111111111111111111111111111111";

		//Test for weak keys
		for( i=0 ; i<4 ; i++ )
		{
			if( keyString.equals( weakKeys[i] ) )
				keyHitCount++;
		}

		//Set the semiWeakKeys
		semiWeakKeys[0]  = "00000001111111000000011111110000000111111100000001111111";
		semiWeakKeys[1]  = "11111110000000111111100000001111111000000011111110000000";
		semiWeakKeys[2]  = "00011111110000000111111100000000111111100000001111111000";
		semiWeakKeys[3]  = "11100000001111111000000011111111000000011111110000000111";
		semiWeakKeys[4]  = "00000001110000000000011100000000000111100000000001111000";
		semiWeakKeys[5]  = "11100000000000111000000000001111000000000011110000000000";
		semiWeakKeys[6]  = "00011111111111000111111111110000111111111100001111111111";
		semiWeakKeys[7]  = "11111110001111111111100011111111111000011111111110000111";
		semiWeakKeys[8]  = "00000000001111000000000011110000000000011100000000000111";
		semiWeakKeys[9]  = "00011110000000000111100000000000111000000000001110000000";
		semiWeakKeys[10] = "11100001111111111000011111111111000111111111110001111111";
		semiWeakKeys[11] = "11111111110000111111111100001111111111100011111111111000";

		//Test for semiWeak keys
		for( i=0 ; i<12 ; i++ )
		{
			if( keyString.equals( semiWeakKeys[i] ) )
				keyHitCount++;
		}

		//Set the demiSemiWeakKeys (without every 8th parity bit)
		demiSemiWeakKeys[0] =  "00011110001111000000000000000000111000011100000000000000";
		demiSemiWeakKeys[1] =  "00000000001111000111100000000000000000011100001110000000";
		demiSemiWeakKeys[2] =  "00011110000000000000000011110000111000000000000000000111";
		demiSemiWeakKeys[3] =  "00000000000000000111100011110000000000000000001110000111";
		demiSemiWeakKeys[4] =  "11100001110000000000000000001111000111100000000000000000";
		demiSemiWeakKeys[5] =  "11111111111111000000000000001111111111111100000000000000";
		demiSemiWeakKeys[6] =  "11111111110000000111100000001111111111100000001110000000";
		demiSemiWeakKeys[7] =  "11100001111111000111100000001111000111111100001110000000";
		demiSemiWeakKeys[8] =  "11111111110000000000000011111111111111100000000000000111";
		demiSemiWeakKeys[9] =  "11100001111111000000000011111111000111111100000000000111";
		demiSemiWeakKeys[10] = "11100001110000000111100011111111000111100000001110000111";
		demiSemiWeakKeys[11] = "11111111111111000111100011111111111111111100001110000111";
		demiSemiWeakKeys[12] = "11111110001111111000000000001111111000011111110000000000";
		demiSemiWeakKeys[13] = "11111110001111111000000000001111111000011111110000000000";
		demiSemiWeakKeys[14] = "11100000001111111111100000001111000000011111111110000000";
		demiSemiWeakKeys[15] = "11111110000000111000000011111111111000000011110000000111";
		demiSemiWeakKeys[16] = "11100000000000111111100011111111000000000011111110000111";
		demiSemiWeakKeys[17] = "00000001110000111000000000000000000111100011110000000000";
		demiSemiWeakKeys[18] = "00011111111111111000000000000000111111111111110000000000";
		demiSemiWeakKeys[19] = "00011111110000111111100000000000111111100011111110000000";
		demiSemiWeakKeys[20] = "00000001111111111111100000000000000111111111111110000000";
		demiSemiWeakKeys[21] = "00011111110000111000000011110000111111100011110000000111";
		demiSemiWeakKeys[22] = "00000001111111111000011110000000000111111111110000000111";
		demiSemiWeakKeys[23] = "00000001110000111111100011110000000111100011111110000111";
		demiSemiWeakKeys[24] = "00011111111111111111100011110000111111111111111110000111";
		demiSemiWeakKeys[25] = "11100000000000000000011100001111000000000000000001111000";
		demiSemiWeakKeys[26] = "11111110001111000000011100001111111000011100000001111000";
		demiSemiWeakKeys[27] = "11111110000000000111111100001111111000000000001111111000";
		demiSemiWeakKeys[28] = "11100000001111000111111100001111000000011100001111111000";
		demiSemiWeakKeys[29] = "11111110000000000000011111111111111000000000000001111111";
		demiSemiWeakKeys[30] = "11100000001111000000011111111111000000011100000001111111";
		demiSemiWeakKeys[31] = "11100000000000000111111111111111000000000000001111111111";
		demiSemiWeakKeys[32] = "11111110001111000111111111111111111000011100001111111111";
		demiSemiWeakKeys[33] = "00011111111111000000011100000000111111111100000001111000";
		demiSemiWeakKeys[34] = "00000001111111000111111100000000000111111100001111111000";
		demiSemiWeakKeys[35] = "00011111110000000000011111110000111111100000000001111111";
		demiSemiWeakKeys[36] = "00000001110000000111111111110000000111100000001111111111";
		demiSemiWeakKeys[37] = "11100000000000000000011100001111000000000000000001111000";
		demiSemiWeakKeys[38] = "11111110001111000000011100001111111000011100000001111000";
		demiSemiWeakKeys[39] = "11111110000000000111111100001111111000000000001111111000";
		demiSemiWeakKeys[40] = "11100000001111000111111100001111000000011100001111111000";
		demiSemiWeakKeys[41] = "11111110000000000000011111111111111000000000000001111111";
		demiSemiWeakKeys[42] = "11100000001111000000011111111111000000011100000001111111";
		demiSemiWeakKeys[43] = "11100000000000000111111111111111000000000000001111111111";
		demiSemiWeakKeys[44] = "11111110001111000111111111111111111000011100001111111111";
		demiSemiWeakKeys[45] = "00011111111111000000011100000000111111111100000001111000";
		demiSemiWeakKeys[46] = "00000001111111000111111100000000000111111100001111111000";
		demiSemiWeakKeys[47] = "00011111110000000000011111110000111111100000000001111111";
		demiSemiWeakKeys[48] = "00000001110000000111111111110000000111100000001111111111";

		//Test for demiSemiWeak keys
		for( i=0 ; i<49 ; i++ )
		{
			if( keyString.equals( demiSemiWeakKeys[i] ) )
				keyHitCount++;
		}

		if( keyHitCount == 0 )
			return( 1 );
		else
			return( 0 );
	}
	//*******************************************************************


	//*******************************************************************
	public byte[] hashPassword( String passwordForHash )
	{
		MessageDigest hashAlgorithm=null;

		//Select hashing algorithm
		try
		{
			hashAlgorithm = MessageDigest.getInstance("SHA-1");
		}
		catch (NoSuchAlgorithmException e)
		{
			System.out.println(e);
    	}

		byte[] passwordBytes = new byte[passwordForHash.length() ];
		passwordBytes = passwordForHash.getBytes();

		//Reset algorithm
		hashAlgorithm.reset();

		//load and hash passwordForHash
		hashAlgorithm.update( passwordBytes );
		byte[] passwordDigest = hashAlgorithm.digest();

		//Reset algorithm
		hashAlgorithm.reset();

		return( passwordDigest );
	}
	//*******************************************************************

	//*******************************************************************
    static byte [] charToByteArray( char c )
    {
		byte [] bytes =
		{
			(byte)(c & 0xff),
		};
		return bytes;
	}
	//*******************************************************************

	//*******************************************************************
	public int exportKeyToDisk( Byte[] rawBytes )
	{
		int status=0;

		return status;
	}
	//*******************************************************************

	//*******************************************************************
	public String decimalToBinary( int decimal )
	{
		String binaryRepresentation="";
		int i=0;

		for( i=7 ; i>=0 ; i-- )
		{
			if( decimal >= Math.pow( 2, i ) )
			{
				binaryRepresentation = binaryRepresentation + "1";
				decimal -= (Math.pow( 2, i ));
			}
			else
				binaryRepresentation = binaryRepresentation + "0";
		}

		return( binaryRepresentation );
	}
	//*******************************************************************


	//*******************************************************************
	public String readFile ( String filename )
	{
		String dat="";

		try
		{
			FileInputStream stream = new FileInputStream( filename );
			DataInputStream in = new DataInputStream( stream );

            while (in.available() !=0)
			{
				dat += in.readLine();
			}

			in.close();
		}
        catch (Exception e)
		{
			JOptionPane.showMessageDialog( this, "File Error", "Error", JOptionPane.ERROR_MESSAGE );
		}

		return( dat );
	}
	//*******************************************************************



	//*******************************************************************
	public void init()
	{
		int i=0;
		String name;

		keyField.setForeground(Color.white);
		keyLabel.setForeground(Color.white);
		keyLabel.setText( "Current Key" );

		//Add the menu bar to the applet
		JMenuBar menu = new JMenuBar();
		setJMenuBar( menu );

		//Create and add the File Menu
		JMenu fileMenu = new JMenu( "File" );
		fileMenu.setMnemonic( 'F' );
		menu.add( fileMenu );

		//Create and add the Key Management Menu
		JMenu keyMenu = new JMenu( "Key Management" );
		keyMenu.setMnemonic( 'K' );
		menu.add( keyMenu );

		//Add to the File menu (sub item encryptFile)
		JMenuItem encryptFile = new JMenuItem( "Encrypt File" );
		encryptFile.setMnemonic( 'E' );
		fileMenu.add( encryptFile );

		//WONT WORK UNLESS THIS IS A SIGNED APPLET - OUT OF SCOPE
		encryptFile.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					String msg = "This wont work unless this is a signed applet by a trusted party! ";
					JOptionPane.showMessageDialog( null, msg, "Security Problem", JOptionPane.INFORMATION_MESSAGE );
		//			JFileChooser fileChooser = new JFileChooser();
		//			String fileString = readFile( fileChooser.getName() );
		//			cipherTextArea.setText( encrypt( fileString, keyField.getText() ) );
		//			Write to file
				}
			}
		);


		//Add to the File menu (sub item decryptFile)
		JMenuItem decryptFile = new JMenuItem( "Decrypt File" );
		decryptFile.setMnemonic( 'D' );
		fileMenu.add( decryptFile );

		//WONT WORK UNLESS THIS IS A SIGNED APPLET - OUT OF SCOPE
		decryptFile.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					String msg = "This wont work unless this is a signed applet by a trusted party! ";
					JOptionPane.showMessageDialog( null, msg, "Security Problem", JOptionPane.INFORMATION_MESSAGE );
		//			JFileChooser fileChooser = new JFileChooser();
		//			String fileString = readFile( fileChooser.getName() );
		//			rawText.setText( decrypt( fileString, keyField.getText() ) );
		//			Write to file
				}
			}
		);

		//Add to the File menu (sub item quit)
		JMenuItem quitApplet = new JMenuItem( "Quit Program" );
		quitApplet.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					System.exit( 0 );
				}
			}
		);
		fileMenu.add( quitApplet );

		//Add to the Key Management menu item (sub item importKey)
		JMenuItem importKey = new JMenuItem( "Import key from disk" );
		importKey.setMnemonic( 'I' );
		keyMenu.add( importKey );

		//WONT WORK UNLESS THIS IS A SIGNED APPLET - OUT OF SCOPE
		importKey.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					String msg = "This wont work unless this is a signed applet by a trusted party! ";
					JOptionPane.showMessageDialog( null, msg, "Security Problem", JOptionPane.INFORMATION_MESSAGE );
		//			JFileChooser fileChooser = new JFileChooser();
		//			String fileString = readFile( fileChooser.getName() );
				}
			}
		);


		//Add to the Key Management menu item (sub item exportKey)
		JMenuItem exportKey = new JMenuItem( "Export key to disk" );
		exportKey.setMnemonic( 'X' );
		keyMenu.add( exportKey );

		//WONT WORK UNLESS THIS IS A SIGNED APPLET - OUT OF SCOPE
		exportKey.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					String msg = "This wont work unless this is a signed applet by a trusted party! ";
					JOptionPane.showMessageDialog( null, msg, "Security Problem", JOptionPane.INFORMATION_MESSAGE );
		//			JFileChooser fileChooser = new JFileChooser();

				}
			}
		);

		//Add to the Key Management menu item (sub item exportKey)
		JMenuItem enterKey = new JMenuItem( "Manually enter key" );
		enterKey.setMnemonic( 'M' );
		keyMenu.add( enterKey );

		//Action listener for manula key entry
		enterKey.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					String enteredKey = JOptionPane.showInputDialog("Please enter a 64-bit key (first 64 taken):");
					String weakKeyString="";
					int i=0, flag=0, weak=1;

					Vector newKeyVector = new Vector();

					//ensure the key is long enough, if not set to bac key (force user to re-enter)
					if( enteredKey.length() < 64 || enteredKey.length() > 64)
						enteredKey = "1111111111111111111111111111111111111111111111111111111111111111";

					newKeyVector.clear();

					//put string into vector
					for( i=0 ; i<64 ; i++ )
					{
						newKeyVector.insertElementAt( enteredKey.substring( i, i+1 ), i );
					}

					//check if weak key
					weak = checkIfWeakKey( newKeyVector );

					//check for chars other than 1 or 0
					for( i=0 ; i<64 ; i++ )
					{
						if( !( enteredKey.charAt( i ) == '1' || enteredKey.charAt( i ) == '0' ) )
							flag=1;

					}

					while( weak == 0 || flag == 1 || enteredKey.length() < 64 || enteredKey.length() > 64)
					{
						newKeyVector.clear();


						weakKeyString = "According to the NIST DES encryption standard that key \n";
						weakKeyString += "is either a weak key, semi-weak key or a demi-semi-weak\n";
						weakKeyString += " key. OR key had characters other than 1 or 0 in it.\n";
						weakKeyString += " OR key is too short. Please enter another 64-bit key:";

						enteredKey = JOptionPane.showInputDialog( weakKeyString );

						//ensure the key is long enough, if not set to weak key (force user to re-enter)
						if( enteredKey.length() < 64 || enteredKey.length() > 64 )
							enteredKey = "1111111111111111111111111111111111111111111111111111111111111111";

						//put string into vector
						for( i=0 ; i<64 ; i++ )
						{
							newKeyVector.insertElementAt( enteredKey.substring( i, i+1 ), i );
						}

						//check if weak key
						weak = checkIfWeakKey( newKeyVector );

						//check for chars other than 1 or 0
						for( i=0 ; i<64 ; i++ )
						{
							if( !( enteredKey.charAt( i ) == '1' || enteredKey.charAt( i ) == '0' ) )
								flag=1;
						}

					}

					//set new key
					keyField.setText( enteredKey );
				}
			}
		);

		//Create panels and set the layout
		JPanel west = new JPanel();
		west.setBackground(Color.darkGray);
		west.setLayout( new GridLayout(1,1,10,10) );
		JPanel east = new JPanel();
		east.setBackground(Color.darkGray);
		east.setLayout( new GridLayout(1,1,10,10) );
		JPanel center = new JPanel();
		center.setBackground(Color.darkGray);
		center.setLayout( new GridLayout(10,1,10,10) );

		JPanel south = new JPanel();
		south.setBackground(Color.darkGray);
		south.setLayout( new GridLayout(2,1,10,10) );

		//Add cipher-text text area
		cipherTextArea.setBackground(Color.white);
		cipherTextArea.setColumns( 40 );
		cipherTextArea.setLineWrap( true );

		//Setup raw-text text area
		rawText.setBackground(Color.white);
		rawText.setText("Please type the text that you wish to encrypt here");
		rawText.setColumns( 35 );
		rawText.setLineWrap( true );

		//Add JLabel for Current Key and add it
		south.add( keyLabel );
		south.add( keyField );

      	//Create the scrollers and add the text areas
        JScrollPane rawTextScroller = new JScrollPane( rawText );
        JScrollPane cipherTextScroller = new JScrollPane( cipherTextArea );

        //Make the buttons
        JButton encryptButton = new JButton( "Encrypt Text ->" );
		encryptButton.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					String cipherText = ( encrypt( rawText.getText(), keyField.getText() ) );
					cipherTextArea.setText( cipherText );
					rawText.setText( "" );
				}
			}
		);

        JButton decryptButton = new JButton( "<- Decrypt Text" );
		decryptButton.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					String plainText = ( decrypt( cipherTextArea.getText(), keyField.getText() ) );
					rawText.setText( plainText );
					cipherTextArea.setText( "" );
				}
			}
		);

        //Make button container
        JPanel buttonContainer = new JPanel();
		buttonContainer.setLayout( new GridLayout(20,20,10,10) );

		//Quick and DIRTY way of putting the buttons in the middle
		for( i=0; i<7; i++ )
		{
			JButton invisibleButton = newFancyButton( "", Color.darkGray, 14 );
			invisibleButton.setBorder(BorderFactory.createEmptyBorder());
			buttonContainer.add( invisibleButton );
		}
		buttonContainer.add( encryptButton );
		buttonContainer.add( decryptButton );

        getContentPane().add(south, BorderLayout.SOUTH);
        getContentPane().add(cipherTextScroller, BorderLayout.EAST);
		getContentPane().add(rawTextScroller, BorderLayout.WEST);
		getContentPane().add(buttonContainer, BorderLayout.CENTER);

		//Add to the Key Management menu item (sub item autoGenerateKey)
		JMenuItem autoGenerateKey = new JMenuItem( "Auto-generate new 64-bit key" );
		autoGenerateKey.setMnemonic( 'A' );
		keyMenu.add( autoGenerateKey );

		//Listener for generating a new 64-bit key
		autoGenerateKey.addActionListener
		(
			new ActionListener()
			{
				public void actionPerformed( ActionEvent e )
				{
					int i=0;
					keyVector = autogenKey();

					vectorString = "";

					for( i=0 ; i<64 ; i++ )
					{
						vectorString += keyVector.elementAt( i );
					}

					keyField.setText( vectorString );
				}
			}
		);

		//Initialize program with new private key
		keyVector = autogenKey();
		for( i=0 ; i<64 ; i++ )
		{
			vectorString += keyVector.elementAt( i );
		}

		keyField.setText( vectorString );

		setSize( 1000, 800 );
		show();
	}
	//*******************************************************************


	//*******************************************************************
	public JButton newFancyButton(String text, Color colour, int size)
	{
		JButton button = new JButton();
		button.setForeground( colour );
		button.setFont(new Font("Arial", Font.PLAIN, size));
		return button;
	}
	//*******************************************************************


	//*******************************************************************
	public static void main( String args[] )
	{
        try
        {
            UIManager.setLookAndFeel( "com.sun.java.swing.plaf.motif.MotifLookAndFeel" );
        }
        catch (Exception e)
        {}

		desEncryption app = new desEncryption();

		JFrame appWindow = new JFrame( "DES Encryption Applet" );

		appWindow.addWindowListener
		(
			new WindowAdapter()
			{
				public void WindowClosing( WindowEvent e )
				{
					System.exit( 0 );
				}
			}
		);
	}
	//*******************************************************************

}
//*******************************************************************